/*
****************************************
-- OpenXML
****************************************
*/

DECLARE @handle int
DECLARE @OrdersXML varchar(max)
SET @OrdersXML = '
<Orders>
  <Customer CustomerID="HERBC" ContactName="Charlie Herb">
     <Order CustomerID="HERBC" EmployeeID="5" OrderDate="2011-11-04">
        <OrderDetail OrderID="10248" ProductID="16" Quantity="12"/>
        <OrderDetail OrderID="10248" ProductID="32" Quantity="10"/>
     </Order>
     <Order CustomerID="HERBC" EmployeeID="2" OrderDate="2011-11-16">
        <OrderDetail OrderID="10283" ProductID="99" Quantity="3"/>
     </Order>
  </Customer>
  <Customer CustomerID="HINKM" ContactName="Matt Hink">
     <Order CustomerID="HINKM" EmployeeID="3" OrderDate="2011-11-23">
        <OrderDetail OrderID="10283" ProductID="99" Quantity="3"/>
     </Order>
  </Customer>
</Orders>'

-- Get a handle onto the XML document
EXEC sp_xml_preparedocument @handle OUTPUT, @OrdersXML

-- Use the OPENXML rowset provider against the handle to parse/query the XML
SELECT *
 FROM OPENXML(@handle, '/Orders/Customer/Order')
 WITH (
  CustomerName varchar(max) '../@ContactName',
  OrderDate date)
