﻿using System;
using System.ComponentModel.DataAnnotations;
using System.Data.Objects.DataClasses;
using System.ServiceModel.DomainServices.Server;

namespace DemoSL.Web
{
  [MetadataTypeAttribute(typeof(Customer.CustomerMetadata))]
  public partial class Customer
  {
    internal sealed class CustomerMetadata
    {
      private CustomerMetadata() { }

      [Composition]
      [Include]
      public EntityCollection<OrderHeader> OrderHeaders { get; set; }

      [RoundtripOriginal]
      public DateTime UpdatedAt { get; set; }
    }
  }

  [MetadataTypeAttribute(typeof(OrderHeader.OrderHeaderMetadata))]
  public partial class OrderHeader
  {
    internal sealed class OrderHeaderMetadata
    {
      private OrderHeaderMetadata() { }

      [RoundtripOriginal]
      public DateTime UpdatedAt { get; set; }
    }
  }
}
