﻿using System;
using System.ComponentModel;
using System.Data.Linq.Mapping;

namespace FlixPoll.LocalData
{
    [Table]
    public class InquiryTable : INotifyPropertyChanged, INotifyPropertyChanging
    {
        private int _inquiryId;
        private string _question;

        [Column(IsPrimaryKey=true, IsDbGenerated=false, DbType="INT NOT NULL", CanBeNull=false)]
        public int InquiryId
        {
            get
            {
                return this._inquiryId;
            }
            set
            {
                if (this._inquiryId != value)
                {
                    NotifyPropertyChanging("InquiryId");
                    this._inquiryId = value;
                    NotifyPropertyChanged("InquiryId");
                }
            }
        }

        [Column]
        public string Question
        {
            get
            {
                return this._question;
            }
            set
            {
                if (this._question != value)
                {
                    NotifyPropertyChanging("Question");
                    this._question = value;
                    NotifyPropertyChanged("Question");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangingEventHandler PropertyChanging;

        private void NotifyPropertyChanging(string propertyName)
        {
            if (PropertyChanging != null)
                PropertyChanging(this, new PropertyChangingEventArgs(propertyName));
        }
    }
}
