﻿using System;
using System.ComponentModel;
using System.Data.Linq;
using System.Data.Linq.Mapping;

namespace FlixPoll.LocalData
{
    // Define the table as a class marked with the [Table] attribute

    [Table]
    public class MovieTable : INotifyPropertyChanged, INotifyPropertyChanging
    {
        public bool MovieChanged { get; set; }

        // Define columns as properties marked with the [Column] attribute

        private int _movieId;

        [Column(IsPrimaryKey = true, IsDbGenerated = false, DbType = "INT NOT NULL",
                 CanBeNull = false)]
        public int MovieId
        {
            get
            {
                return _movieId;
            }
            set
            {
                if (_movieId != value)
                {
                    NotifyPropertyChanging("MovieId");
                    _movieId = value;
                    NotifyPropertyChanged("MovieId");
                }
            }
        }

        private string _name;

        [Column]
        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                if (_name != value)
                {
                    // used to track if update has taken place
                    if (this._name != null)
                        this.MovieChanged = true;

                    NotifyPropertyChanging("Name");
                    this._name = value;
                    NotifyPropertyChanged("Name");
                }
            }
        }

        private bool _updateToCloud;

        [Column]
        public bool UpdateToCloud
        {
            get
            {
                return _updateToCloud;
            }
            set
            {
                if (_updateToCloud != value)
                {
                    NotifyPropertyChanging("IsChanged");
                    _updateToCloud = value;
                    NotifyPropertyChanged("IsChanged");
                }
            }
        }

        // Notify the page that a data context property changed
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        // Notify the data context that a data context property is about to change
        public event PropertyChangingEventHandler PropertyChanging;

        private void NotifyPropertyChanging(string propertyName)
        {
            if (PropertyChanging != null)
            {
                PropertyChanging(this, new PropertyChangingEventArgs(propertyName));
            }
        }
    }
}