﻿using System;
using System.ComponentModel;
using System.Data.Linq;
using System.Data.Linq.Mapping;

namespace FlixPoll.LocalData
{
    [Table]
    public class ResponseTable : INotifyPropertyChanged, INotifyPropertyChanging
    {
        private int _responseId;
        private int _inquiryId;
        private int _movieId;
        private string _question;
        private bool _answer;

        [Column(IsPrimaryKey = true, IsDbGenerated = false, DbType = "INT NOT NULL", CanBeNull = false)]
        public int ResponseId
        {
            get
            {
                return this._responseId;
            }
            set
            {
                if (this._responseId != value)
                {
                    NotifyPropertyChanging("ResponseId");
                    this._responseId = value;
                    NotifyPropertyChanged("ResponseId");
                }
            }
        }

        [Column]
        public int InquiryId
        {
            get
            {
                return this._inquiryId;
            }
            set
            {
                if (this._inquiryId != value)
                {
                    NotifyPropertyChanging("InquiryId");
                    this._inquiryId = value;
                    NotifyPropertyChanged("InquiryId");
                }
            }
        }

        [Column]
        public int MovieId
        {
            get
            {
                return this._movieId;
            }
            set
            {
                if (this._movieId != value)
                {
                    NotifyPropertyChanging("MovieId");
                    this._movieId = value;
                    NotifyPropertyChanged("MovieId");
                }
            }
        }

        [Column]
        public string Question
        {
            get
            {
                return this._question;
            }
            set
            {
                if (this._question != value)
                {
                    NotifyPropertyChanging("Question");
                    this._question = value;
                    NotifyPropertyChanged("Question");
                }
            }
        }

        [Column]
        public bool Answer
        {
            get
            {
                return this._answer;
            }
            set
            {
                if (this._answer != value)
                {
                    NotifyPropertyChanging("Answer");
                    this._answer = value;
                    NotifyPropertyChanged("Answer");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangingEventHandler PropertyChanging;

        private void NotifyPropertyChanging(string propertyName)
        {
            if (PropertyChanging != null)
                PropertyChanging(this, new PropertyChangingEventArgs(propertyName));
        }
    }
}
